// Christian Duncan
// Edge Class
//    for GD2004, Graph Drawing Contest

// package GD4;

/*********************
 * An Edge in the Graph
 *    Has two parts - start and end to the edge
 *    These are Nodes
 *    Ideally we could make it more space efficient
 *    And store just Destination as every edge is attached
 *    to a start Node anyway.
 *    But this allows greater flexibility in the future
 *    Notice that edges are undirected, so start and end are just
 *    names for the two nodes (for now).
 * Edges currently are immutable (can only access end points)
 *********************/
public class Edge {
    private Node start, end;

    public Edge(Node _start, Node _end) {
	start = _start; end = _end; 
    }

    /* Accessor methods */
    public Node getStartNode() { return start; }
    public Node getEndNode() { return end; }

    /* Return length of edge */
    public double length() { return start.distance(end); }
    public double sqrLength() { return start.sqrDistance(end); }
}
